<script setup lang="ts">
  import get from 'lodash/get';
  import { ProductListingKey } from '~/helpers/injection';

  const { listingType } = inject(ProductListingKey)!;

  const { getSortingOrders } = useListing({
    listingType,
  });

  const props = defineProps<{
    modelValue?: string;
  }>();

  const emits = defineEmits(['update:modelValue']);

  const options = computed(() => {
    return getSortingOrders.value.map((el) => ({
      key: el.key,
      label: get(el, 'translated.label', el.label),
    }));
  });

  const currentSortingOrders = computed(() => {
    return options.value.find((el) => el.key === props.modelValue);
  });

  const handleChange = (key: string) => {
    emits('update:modelValue', key);
  };
</script>

<template>
  <SwSelect
    key-field="key"
    label-field="label"
    :options="options"
    :placeholder="currentSortingOrders?.label"
    size="large"
    :model-value="props.modelValue"
    @update:model-value="handleChange"
  />
</template>
